// include para FILE, 'fopen', 'fgetc', 'fclose'
#include <stdio.h>
// includes para 'open':
#include <sys/stat.h> 
#include <fcntl.h>
// include para 'read', 'close'
#include <unistd.h>

#define BUFFER_SIZE 17
#define MAX 200

int main (int argc, char *argv[]) {

  // FILE eh uma estrutura que guarda todas as informações do arquivo aberto
  FILE *parq1;
  int fd, ch1, i;
  unsigned char buffer[BUFFER_SIZE];
  char string[MAX];
  float f_num;

  // arquivo aberto apenas para leitura
  parq1 = fopen("exemplo1.txt", "r");

  // 'open' geralmente soh funciona em sistemas POSIX (Linux, BSD, etc.), 
  // portanto prefira 'fopen' para codigo portavel
  // Mais informacoes: http://stackoverflow.com/a/1658517
  fd = open("exemplo2.txt", O_RDONLY);

  // FILE* pode ser usado em funcoes como 'fgetc', 'fprintf', etc.

  // 'fgets' le uma string ate encontrar '\n', EOF ou no maximo MAX caracteres
  fgets(string, MAX, parq1);
  printf("fgets: %s", string);   // '\n' ja faz parte da string lida

  // 'fgetc' le um caractere por vez:
  for (i = 0; i < 13; i++) {
    ch1 = fgetc(parq1);
    printf("fgetc: %c\n", ch1);
  }

  // 'fread' le um bloco de bytes por vez:
  fread(buffer, 1, BUFFER_SIZE-1, parq1); 
  buffer[BUFFER_SIZE-1] = '\0';  // faz do bloco de bytes uma string valida
  printf("fread: %s\n", buffer);

  // 'fscanf' le dados com formato especifico:
  fscanf(parq1, "%f", &f_num);
  printf("fscanf: %f\n", f_num);

  // 'fseek' Eh usado para buscar posicoes especificas no arquivo:
  //fseek(parq1, BUFFER_SIZE-1, SEEK_CUR);
  fseek(parq1, -5, SEEK_END);
  int bytesLidos = 0;
  bytesLidos = fread(buffer, 1, BUFFER_SIZE-1, parq1);
  buffer[bytesLidos] = '\0';
  printf("fseek (%d) from SEEK_CUR + fread: %s\n", BUFFER_SIZE-1, buffer);

  // O descritor de 'open' pode ser usado em 'read', 'write', etc.

  // 'read' le um bloco de bytes por vez:
  read(fd, buffer, BUFFER_SIZE-1);
  buffer[BUFFER_SIZE-1] = '\0';  // faz do bloco de bytes uma string valida
  printf("read: %s\n", buffer);  

  // 'lseek' Eh usado para buscar posicoes especificas no arquivo:
  lseek(fd, BUFFER_SIZE-1, SEEK_SET);
  read(fd, buffer, BUFFER_SIZE-1);
  printf("lseek (%d) + read: %s\n", BUFFER_SIZE-1, buffer);  

  // Fecha arquivo aberto com 'fopen':
  fclose(parq1);

  // Fecha arquivo aberto com 'open':
  close(fd);

  return 0;
}
